c@a
c@versb
C-----------------------------------------------------------------------
C
CVERS                  Code_Saturne version 1.3
C                      ------------------------
C
C     This file is part of the Code_Saturne Kernel, element of the
C     Code_Saturne CFD tool.
C 
C     Copyright (C) 1998-2007 EDF S.A., France
C
C     contact: saturne-support@edf.fr
C 
C     The Code_Saturne Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C 
C     The Code_Saturne Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C 
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
c@verse
                        SUBROUTINE MEMNVC
C                       *****************
C     -------------------------------------------------------------
     & ( IDBIA0 , IDBRA0 ,
     &   NDIM   , NCELET , NCEL   , NFAC   , NFABOR ,
     &   NNOD   , LNDFAC , LNDFBR ,
     &   IINMFI , IINMFB ,
     &   IIWORK , IISMBS , IISMBV ,
     &   IIPFAW , INOFAW , IIPFBW , INOFBW ,
     &   IRWORK , IRSMBS , IRSMBV ,
     &   IFINIA , IFINRA )
C     -------------------------------------------------------------
C***********************************************************************
C  FONCTION
C  --------
c@foncb
CFONC
CFONC  GESTION MEMOIRE POUR LA RENUMEROTATION DES FACES
CFONC
c@fonce
C-----------------------------------------------------------------------
C                                  ARGUMENTS
c@argub
CARGU .______________.____._____.______________________________________.
CARGU !    NOM       !TYPE!MODE !                   ROLE               !
CARGU !______________!____!_____!______________________________________!
CARGU ! IDBIA0/IDBRA0! E  !  -> ! POINTEUR DE LA PREMIERE CAS LIBRE DES!
CARGU !              !    !     !  TABLEAUX IA/RA                      !
CARGU ! NDIM         ! E  !  -> ! DIMENSION DE L'ESPACE                !
CARGU ! NCELET       ! E  !  -> ! NOMBRE D'ELEMENTS HALO COMPRIS       !
CARGU ! NCEL         ! E  !  -> ! NOMBRE D'ELEMENTS ACTIFS             !
CARGU ! NFAC  /NFABOR! E  !  -> ! NOMBRE TOTAL DE FACES INTERNES/DE BOR!
CARGU ! NNOD         ! E  !  -> ! NOMBRE DE SOMMETS                    !
CARGU ! LNDFAC       ! E  !  -> ! LONGUEUR DU TABLEAU NODFAC (OPTIONNEL!
CARGU ! LNDFBR       ! E  !  -> ! LONGUEUR DU TABLEAU NODFBR (OPTIONNEL!
CARGU ! IINMFI       ! E  ! <-  ! POINTEUR SUR INUMFI                  !
CARGU ! IINMFB       ! E  ! <-  ! POINTEUR SUR INUMFB                  !
CARGU ! IIWORK       ! E  ! <-  ! POINTEUR SUR IWORKF                  !
CARGU ! IISMBS       ! E  ! <-  ! POINTEUR SUR ISMBS                   !
CARGU ! IISMBV       ! E  ! <-  ! POINTEUR SUR ISMBV                   !
CARGU ! IIPFAW       ! E  ! <-  ! POINTEUR SUR IPNFAW                  !
CARGU ! INOFAW       ! E  ! <-  ! POINTEUR SUR INOFAW                  !
CARGU ! IIPFBW       ! E  ! <-  ! POINTEUR SUR IPNFBW                  !
CARGU ! INOFBW       ! E  ! <-  ! POINTEUR SUR INOFBW                  !
CARGU ! IRWORK       ! E  ! <-  ! POINTEUR SUR RWORKF                  !
CARGU ! IRSMBS       ! E  ! <-  ! POINTEUR SUR RSMBS                   !
CARGU ! IRSMBV       ! E  ! <-  ! POINTEUR SUR RSMBV                   !
CARGU ! IFINIA       ! E  ! <-  ! POINTEUR DE LA PREMIERE CAS LIBRE DAN!
CARGU !              ! E  !     !  DANS IA EN SORTIE                   !
CARGU ! IFINRA       ! E  ! <-  ! POINTEUR DE LA PREMIERE CAS LIBRE DAN!
CARGU !              ! E  !     !  DANS RA EN SORTIE                   !
CARGU .______________.____._____.______________________________________.
c@argue
C
c@commb
CCOMM                             COMMONS
CCOMM .______________.____._____.______________________________________.
CCOMM !    NOM       !TYPE!MODE !                   ROLE               !
CCOMM !______________!____!_____!______________________________________!
CCOMM !______________!____!_____!______________________________________!
c@comme
C
C     TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C            L (LOGIQUE)   .. ET TYPES COMPOSES (EX : TR TABLEAU REEL)
C     MODE : -> DONNEE, <- RESULTAT, <-> DONNEE MODIFIEE,
C            - TABLEAU DE TRAVAIL
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON
C***********************************************************************
C
C***********************************************************************
C
C ARGUMENTS
C
      INTEGER IDBIA0, IDBRA0, NDIM  , NCELET, NCEL, NFAC, NFABOR
      INTEGER NNOD  , LNDFAC, LNDFBR
      INTEGER IINMFI, IINMFB
      INTEGER IIWORK, IISMBS, IISMBV
      INTEGER IIPFAW, INOFAW, IIPFBW, INOFBW
      INTEGER IRWORK, IRSMBS, IRSMBV
      INTEGER IFINIA, IFINRA
C
C VARIABLES LOCALES
C
      INTEGER IDEBIA, IDEBRA, ILNDFA, ILNDFB
C
C***********************************************************************
C
C---> INITIALISATION
C
      IDEBIA = IDBIA0
      IDEBRA = IDBRA0
C
C  Indicateurs d'existence de la connectivite noeuds faces
      ILNDFA = 0
      ILNDFB = 0
      IF(LNDFAC.GT.0) THEN
        ILNDFA = 1
      ENDIF
      IF(LNDFBR.GT.0) THEN
        ILNDFB = 1
      ENDIF
C
C---> PLACE MEMOIRE RESERVEE AVEC DEFINITION DE IFINIA IFINRA
C
      IINMFI = IDEBIA
      IINMFB = IINMFI + NFAC
      IIWORK = IINMFB + NFABOR
      IISMBS = IIWORK + MAX(NFAC,NFABOR)
      IISMBV = IISMBS + NCELET
      IIPFAW = IISMBV + NCELET
      INOFAW = IIPFAW + (NFAC+1)   * ILNDFA
      IIPFBW = INOFAW + LNDFAC     * ILNDFA
      INOFBW = IIPFBW + (NFABOR+1) * ILNDFB
      IFINIA = INOFBW + LNDFBR     * ILNDFB
C
      IRWORK = IDEBRA
      IRSMBS = IRWORK + MAX(NFAC,NFABOR)
      IRSMBV = IRSMBS + NCELET
      IFINRA = IRSMBV + NCELET
C
C---> VERIFICATION
C
      CALL IASIZE('MEMNVC',IFINIA)
C     ==========
C
      CALL RASIZE('MEMNVC',IFINRA)
C     ===========
C
      RETURN
      END
c@z
